import jinro.*;
import scripts.*;
import scripts.roles.*;
import java.text.Collator;
import java.security.SecureRandom
import com.skype.*;
import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;

class Game extends System {
	def strings = super.strings.attachBundle("Game.properties");
	def time0 = 0;
	// Argument time (minutes)
	def argumenttime = 7;
	// Night time (minutes)
	def nighttime = 3;
	// Limits the frequency of revotes per day.
	// If frequency of revotes exceeds the limit, the game ends in a draw.
	def revotelimit = 3;
	// Keeps roles/death secret from viewers if it's true.
	def firstdaytime = 0;	//初日の時間（希望役職=3、恋人決め=1）
	def minifoxprobability = 50	//子狐の占い確率［％］
	def issecret = true;		//非開示 true=非開示
	def gameend = false;		//ゲーム終了（開示にする）true=終了（役職強制開示） false=まだ終わってない
	def usedeathnote = false;	//デスノート
	def deathnoterand = false;	//デスノートランダム
	def deviltrigger = false;	//デビトリ
	def deviltriggerrand = false;	//デビトリランダム
	def cupid = false;			//キューピット
	def loversfellow = false;	//恋人道連れ
	def cathang = true;			//猫吊り即るー
	def catbitecurse = true;	//猫噛み狼死亡
	def foxchat = true;			//妖狐の念話
	def minifoxchat = true;		//子狐チャット
//	def fanatic = false;		//狂信者に狼の位置を教える
	def norenzokuguard = false;	//狩人の連続護衛禁止
	def firstfortune = true;	//初日犠牲者は占いを行う
	def roledisplay = true;		//配役表示
	def autospiritschat = true;	//自動霊界生成
	def zerodayrandom = false;	//初日、役職をランダムで実行
	def zerodayrandombeginners = false;	//初日役職ランダム実行で黒や呪殺を出さない。
	def zerodayrandomfortune = false;	//占いランダム＠ true=有効 false=無効
	def sedeathdisplay = 2;		//SE上の死亡表示0～2
	def senumdisplay = 1;		//SE上の生存人数表示
	def setimedisplay = true;	//SEのリスト内に時間表示
	def randomlovers = 0;		//ランダム恋人
	def randomloversflg = false;	//オプションにランダム恋人人数を表示
	def zerodaynofortune = false;	//初日の占い無し
	def dealrolesrandom = false;	//役職を比率でランダム
	def votetime = 0;		//投票時間[分]
	def voteremainingtime = 30;	//投票残り時間[秒]で催促
	def roleremainingtime = 30;	//役職実行残り時間[秒]で催促
	def tievoterandom = false;	//同票でランダム処刑
	def leavingseat = false;	//夜時間に離席＠を受け付ける
	def roledisplaymethod = 1;	//配役表示の表示方法 0=配役のみ、1=オプションも表示
	def hoperole = false;		//希望役職
	def voteddisp = true;		//投票済表示
	def autohold = false;		//自動保留
	def listroles = [];			//役職リスト
	def waittime = 1000;		//一覧表示前後のウエイト
	def rolecompletiondialog = false;	//役職完了ダイアログ表示
	def votecompletiondialog = true;	//投票完了ダイアログ表示
	def survivalnumber = true;	//現在何名生存です。
	def yagamo = true;			//矢鴨（恋人に複数矢が刺さるか？）true=複数 false=１つのみ
	def catrevival = false;		//猫又蘇生
	def catascetic = false;		//猫又を修験者
	def oldbakersize = 0;		//以前のパン屋の人数
	def tas = false;			//TASチェック
	def tasflg = false;			//TASフラグ（ダミー）
	def ktime = 1;				//killで使用する時間UPDATE前の時間を保持 0=夕方（吊り） 1=夜明け
	def existnine = false;		//九尾が配役に含まれているか？
	def minsectime = 20;		//時間を分と秒で分ける値 この値未満で分、この値以上で秒
	def votetimeflg = false;	//投票時間か？ true=投票時間
	def voteflg = false;		//村人の投票画面 false=出さない　true=出す
	def votecheckcount = 0;		//チェックのカウント
	def daytimeend = false;		//義論時間が0=true
	def execactor;				//吊られた人
	def bitetarget = null;
	def killedMessages = [];
	Random r = new SecureRandom();
	
	def Game() {
		//乱数初期化っぽい奴
		100.times { rand(); }
				
		//設定読み込み
		JinroGame.log.add( strings.getString("village.name") );
/*		String path = JinroGame.getScriptsDirectory().getCanonicalPath() + "\\Nakajima.ini";
		String basepath = (new File(java.lang.System.getProperty("java.class.path"))).getParent();
		def flg = false;
		def len = basepath.length();
		if(len > path.length()) len = path.length()-1;
		for(int i=0; i< len; i++) {	//パスチェック（何故か文字列比較でエラーなので1byteずつ）
			if( basepath.charAt(i) != path.charAt(i) ) {
				flg = true;
				break;
			}
		}*/
//		JinroSettings setting = JinroSettings.getSettings(path);
		JinroSettings setting = JinroSettings.getSettings("scripts\\nakajima0.97\\Nakajima.ini");
		if(setting != null) {
			issecret = setting.getBoolData("issecret",true);			//非開示
			tievoterandom = setting.getBoolData("tievoterandom",false);	//同票でランダム処刑
			usedeathnote = setting.getBoolData("usedeathnote",false);	//デスノート
			deviltrigger = setting.getBoolData("deviltrigger",false);	//デビトリ
			loversfellow = setting.getBoolData("loversfellow",false);	//恋人道連れ
			cathang = setting.getBoolData("cathang",true);				//猫吊り即るー
			catbitecurse = setting.getBoolData("catbitecurse",true);	//猫噛み狼死亡
			catrevival = setting.getBoolData("catrevival",false);		//希望役職
			catascetic = setting.getBoolData("catascetic",false);		//猫又を修験者
			foxchat = setting.getBoolData("foxchat",true);				//妖狐の念話
			minifoxchat = setting.getBoolData("minifoxchat",true);		//子狐チャット
		//	fanatic = setting.getBoolData("fanatic",false);				//狂信者に狼の位置を教える
			norenzokuguard = setting.getBoolData("norenzokuguard",false);	//連続護衛禁止
			firstfortune = setting.getBoolData("firstfortune",true);	//初日犠牲者は占いを行う
			roledisplay = setting.getBoolData("roledisplay",true);		//配役表示
			autospiritschat = setting.getBoolData("autospiritschat",true);	//自動霊界生成
			zerodayrandom = setting.getBoolData("zerodayrandom",false);	//初日、役職をランダムで実行
			zerodaynofortune = setting.getBoolData("zerodaynofortune",false);	//初日の占い無し
			zerodayrandombeginners = setting.getBoolData("zerodayrandombeginners",false);	//初日ランダムで黒や呪殺を出さない
			dealrolesrandom = setting.getBoolData("dealrolesrandom",false);	//役職配布を比率でランダム
			hoperole = setting.getBoolData("hoperole",false);			//希望役職
			voteddisp = setting.getBoolData("voted",false);				//投票済表示
//			autohold = setting.getBoolData("autohold",false);			//自動保留
			
			sedeathdisplay = setting.getIntData("sedeathdisplay",2);	//SE上の死亡表示0～2
			senumdisplay = setting.getIntData("senumdisplay",1);		//SE上の生存人数表示0～2
			roledisplaymethod = setting.getIntData("roledisplaymethod",1);	//配役表示の表示方法
			votetime = setting.getIntData("votetime",0);				//投票時間
			voteremainingtime = setting.getIntData("voteremainingtime",30);	//投票残り時間[秒]で催促
			roleremainingtime = setting.getIntData("roleremainingtime",30);	//役職実行残り時間[秒]で催促
			randomlovers = setting.getIntData("randomlovers",0);		//ランダム恋人
			if(randomlovers < 0) {
				randomloversflg = true;
				randomlovers = 0;
			}
			if(randomlovers > 0) {
				JinroGame.log.add(strings.getString("randomlovers.0",randomlovers));
				//randomlovers.0=ランダム恋人が設定されています。カップル数は%S組みです。
			}
			yagamo = setting.getBoolData("yagamo",true);				//矢鴨（１人の人が複数の恋人になる）
			tas = setting.getBoolData("tas",false);						//TASチェック
			leavingseat = setting.getBoolData("leavingseat",false);		//離席＠を受け付ける
			zerodayrandomfortune = setting.getBoolData("zerodayrandomfortune",false);	//占いランダム＠
			waittime = setting.getIntData("waittime",1000);				//一覧表示前後のウエイト
			votecompletiondialog = setting.getBoolData("votecompletiondialog",false);	//投票実行完了ダイアログ表示
			rolecompletiondialog = setting.getBoolData("rolecompletiondialog",false);	//役職実行完了ダイアログ表示
			survivalnumber = setting.getBoolData("survivalnumber",false);	//現在何名生存です。を朝に表示するか？
		} else {
			JinroGame.log.add("Nakajima.iniを読み込めませんでした。");
//			JinroGame.log.add("JinroSEのscriptsフォルダにnakajima0.xxのフォルダを入れて下さい。");
		}
	}
	
	// Returns the game options.
	// This method is called by JinroGame.getOptionList().
	def getOptionList() {
		def list = [];
		
		list << [strings.getString("option.argumenttime"), "argumenttime", "Integer"];	//昼時間
		list << [strings.getString("option.nighttime"), "nighttime", "Integer"];		//夜時間
		list << [strings.getString("option.votetime"), "votetime", "Integer"];	//投票時間
		list << [strings.getString("option.revotelimit"), "revotelimit", "Integer"];	//再投票回数
		list << [strings.getString("option.issecret"), "issecret", "Boolean"];			//非開示
		list << [strings.getString("option.minifoxprobability"), "minifoxprobability", "Integer"];	//子狐の占い確率
		list << [strings.getString("option.autospiritschat"), "autospiritschat", "Boolean"];	//自動霊界生成
		list << [strings.getString("option.foxchat"), "foxchat", "Boolean"];			//妖狐の念話
		list << [strings.getString("option.norenzokuguard"), "norenzokuguard", "Boolean"];	//狩人の連続護衛禁止
		list << [strings.getString("option.minifoxchat"), "minifoxchat", "Boolean"];	//子狐チャット
		list << [strings.getString("option.usedeathnote"), "usedeathnote", "Boolean"];	//デスノート
//		list << [strings.getString("option.deathnoterand"), "deathnoterand", "Boolean"];//デスノートランダム
		list << [strings.getString("option.deviltrigger"), "deviltrigger", "Boolean"];	//デビトリ
//		list << [strings.getString("option.deviltriggerrand"), "deviltriggerrand", "Boolean"];	//デビトリランダム
//		list << [strings.getString("option.cupid"), "cupid", "Boolean"];				//キューピット
//		list << [strings.getString("option.fanatic"), "fanatic", "Boolean"];			//狂信者
		list << [strings.getString("option.tievoterandom"), "tievoterandom", "Boolean"];	//同票ランダム処刑
		if(tas == true) {
			list << [strings.getString("option.tas"), "tasflg", "Boolean"];	//TASチェック
		}
		list << [strings.getString("option.loversfellow"), "loversfellow", "Boolean"];	//恋人道連れ
		list << [strings.getString("option.cathang"), "cathang", "Boolean"];			//猫吊り即るー
		list << [strings.getString("option.catbitecurse"), "catbitecurse", "Boolean"];	//猫噛み狼死亡
		list << [strings.getString("option.catrevival"), "catrevival", "Boolean"];	//猫又蘇生
		list << [strings.getString("option.catascetic"), "catascetic", "Boolean"];	//猫又を修験者
		
		if(roledisplaymethod == 0) {
			list << [strings.getString("option.roledisplay.0"), "roledisplay", "Boolean"];	//配役表示
		} else {
			list << [strings.getString("option.roledisplay.1"), "roledisplay", "Boolean"];	//配役表示
		}
		list << [strings.getString("option.zerodaynofortune"), "zerodaynofortune", "Boolean"];	//初日の占い無し
		list << [strings.getString("option.zerodayrandom"), "zerodayrandom", "Boolean"];	//初日、役職をランダムで実行
		list << [strings.getString("option.firstfortune"), "firstfortune", "Boolean"];	//初日犠牲者は占いを行う
		list << [strings.getString("option.zerodayrandombeginners"), "zerodayrandombeginners", "Boolean"];	//初日役職ランダム実行の時、黒や呪殺を出さない
		list << [strings.getString("option.dealrolesrandom"), "dealrolesrandom", "Boolean"];	//役職配布を比率でランダム
		list << [strings.getString("option.hoperole"), "hoperole", "Boolean"];			///希望役職
		list << [strings.getString("option.voted"), "voteddisp", "Boolean"];			///投票済表示
//		list << [strings.getString("option.autohold"), "autohold", "Boolean"];			///自動保留
		
		if(randomloversflg == true) {
			list << [strings.getString("option.randomlovers"), "randomlovers", "Integer"];	//ランダム恋人カップル数
		}
		return list;
	}
	// Returns the actors data (for displaying).
	// This method is called by JinroGame.getActorsData().
	//ツールでの表示に用いる参加者データを返します。
	def getActorsData() {
		def list = [];
		actors.each { actor ->
			def data = [];
			data[1] = actor.name;
			// Hides roles and death from viewers if the game is secret mode. 死因を隠すか？
			def secret = issecret; //true=非開示
			if(gameend == true) { secret = false; }		//終了時は強制公開
			if(secret && actor.state.priority < 49 && actor.state != State.escaped) {
				data[0] = State.bitten.priority;
				data[3] = strings.getString("secret.death");
				//secret.death=死亡
			} else {
				data[0] = actor.state.priority;
				data[3] = actor.state.name;			//state.nameに死因が入る？
			}
			if(data[0] <= 50)
			{
				data[0] = actor.killtime;
				def d = (actor.killtime/2) as int;
				if(sedeathdisplay > 0) {
					def state = data[3];
					if(sedeathdisplay == 2) {
						state = state.replaceAll("死亡","");
					}
					data[3] = d + strings.getString("notice.date") + state;
					//notice.date=日目
				}
			}
			if(secret) {		//非開示の場合
				data[2] = strings.getString("secret.role");
				//secretvoted=投票済
				if (actor.voted && voteddisp ){
					data[2] = strings.getString("secretvoted");
				}
				data[4] = 0;
				//secret.role=？
			} else {			//開示の場合
				data[2] = JinroGame.getAlias(actor.getRoleName());
				data[4] = actor.getPriority();
				if(deviltriggerrand == false) {
				//	if( (actor.deviltrigger == true) && actor.roleIs(new Civilian()) ) {
					if(actor.DTbyCivilian == true) {
						data[2] =  strings.getString("IhaveDT");
						//IhaveDT=村人(デビルトリガー)
						data[4] += 1;
					}
				}
				if(actor.cupid == true) {
					data[2] =  strings.getString("cupid");
					//cupid=キューピット
				}
		/*		if(actor.lovers != 0) {
					if(cupidnum > 1) {
						data[2] =  strings.getString("lovers") + actor.loversmark + "(" + data[2] + ")";
					} else {
						data[2] =  strings.getString("lovers") + "(" + data[2] + ")";
					}
				}
				if(actor.keep != 0) {
					if(cupidnum > 1) {
						data[2] =  strings.getString("lovers") + actor.loversmark + "(" + data[2] + ")";
					} else {
						data[2] =  strings.getString("keep") + "(" + data[2] + ")";
					}
				}//*/
				
				if(cupidnum > 1) {
					if( (actor.lovers != 0) || (actor.keep != 0) ) {
						data[2] =  strings.getString("lovers") + actor.loversmark + "(" + data[2] + ")";
					}
				} else {
					if(actor.lovers != 0) {
						data[2] =  strings.getString("lovers") + "(" + data[2] + ")";
					}
					if(actor.keep != 0) {
						data[2] =  strings.getString("keep") + "(" + data[2] + ")";
					}
				}
				
				if( (gameend == true) && (hoperole == true) ) {
					if(actor.hoperolename != null) {
						data[2] += strings.getString("role.hope",actor.hoperolename );
						//role.hope=(希望:%S)
					}
				}
				if (actor.voted && voteddisp ){
					data[2] = strings.getString("voted") + data[2];
					//voted=済)
				}
			}
			list << data;
		};
		// Sort the actors.
		def collator = Collator.getInstance(JinroLocalization.getLocale());
		collator.setStrength(Collator.PRIMARY);
		list.sort { one, two ->
			if(one[0] != two[0]) {
				// Actor's state
				return two[0] - one[0];
			} else if(one[4] != two[4]) {
				// Actor's role
				return two[4] - one[4];
			} else {
				// Actor's name
				return collator.compare(one[1], two[1]);
			}
		}
		def lives = actors.findAll{ it.isLive() };
		if(list && lives) {
			def num = 0;
			if((list.size() > 0) && (setimedisplay == true)) {
				num = 1;
				def data0 = [];
				data0 = list[0];
				def min = JinroInterface.timerMinute.getSelection();
				def sec = JinroInterface.timerSecond.getSelection();
				data0[3] = strings.getString("notice.minsec",min,sec);
				//notice.minsec=%S分%S秒
				list[0] = data0;
			}
			if((list.size() > num) && (senumdisplay > 0)) {
				def data = [];
				data = list[num];
				data[3] = lives.size() + strings.getString("survivors");
				//survivors=名生存
				list[num] = data;
				
				if((list.size() > num+1) && (lives.size() > num+1) && (senumdisplay > 1)) {
					def data2 = [];
					data2 = list[num+1];
					def n = 0;
					if(JinroGame.time == 0) {
						n = Math.floor((lives.size()/2)+0.5) -1 as int;
					} else {
						n = Math.floor(((lives.size()-1)/2)+0.5) -1 as int;
					}
					if((JinroGame.day == 0) && (JinroGame.time == 1)) { n++; };
				//	data2[3] = lives.size()+3 + strings.getString("survivors");
					data2[3] = data2[3] + "" + n + strings.getString("hungnum");
					//hungnum=吊
					list[num+1] = data2;
				}
			}
		}
		return list;
	}
	// This method is called by JinroInterface.Update.CountDown.run().
	// If it returns true , the tool notifies all actors of the remaining time.
	//               false, you should write a code of notifying here.
	//ツール本体のタイマーがカウントされるごとに呼び出されます。
	//残り時間によって何らかの処理を行う場合にこのメソッドを利用出来ます。
	def timerCounted(minutes, seconds) {
		JinroInterface.refreshUserList();
		def sec = minutes*60 + seconds;
		switch(JinroGame.time + firstdaytime*2) {
			case 0:	//昼
				if(sec == 0) {
					statecheck();	//生死が変化してないか確認＆表示
					if(votetimeflg == false) {	//投票がまだ
						daytimeend = true;
				/*		votetimeflg = true;
						noticeall(strings.getString("notice.vote.execute"));
						//notice.vote.execute=投票時間です。「投票＠対象の名前」を個人チャットに入力して投票をお願いします。
						if(votetime > 0) {
							JinroInterface.setTimer(votetime, 0);
							JinroInterface.countdown = true;		//投票時間のタイマー動作開始
						}//*/
					//	noticeall("保留します(｀・ω・´) ");
					/*	if(autohold == true) {
							//時間切れと共に保留
							Call[] active = Skype.getAllActiveCalls();
							if(active.length > 0) {
								active.each { it.hold() };
							}
						}//*/
					} else {	//投票時間
						if((check.size() > 0) && (votetime > 0)) {
							check.each {
								it.notice(strings.getString("notice.vote.execute.end"));
								//notice.vote.execute.end=投票時間が終わりました。早く投票して下さい。
							}
						}
					}
				}
				if( (sec == voteremainingtime) && (voteremainingtime > 0) ) {
					if(votetimeflg == true) {	//投票時間
						if((check.size() > 0) && (votetime > 0)) {
							def m = (sec / 60) as int;
							def s = sec - m*60;
							def time;
							if((m != 0) && (s != 0)) {
								time = strings.getString("notice.minsec",m,s);
								//notice.minsec=%S分%S秒
							} else {
								if(m == 0) {
									time = strings.getString("notice.sec",s);
									//notice.sec=%S秒
								} else {
									time = strings.getString("notice.min",m);
									//notice.min=%S分
								}
							}
							check.each {
								it.notice(strings.getString("notice.vote.execute.remainingtime",time));
								//notice.vote.execute.remainingtime=あと%Sです。早く投票をお願いします。
							}
						}
					}
				}
				break;
			case 1:	//夜
				if(sec == 0) {
					if(check.size() > 0) {
						check.each {
							it.notice(strings.getString("notice.role.execute.end"));
							//notice.role.execute.end=夜時間が終わりました。早く役職実行して下さい。
						}
						if(JinroGame.day > 0) {
							if(!Wolf.bitetarget) {
								if(wolveschat != null) {
									wolveschat.send(strings.getString("notice.role.execute.end"));
								}
							}
						}
					}
				}
				if( (sec == roleremainingtime) && (roleremainingtime > 0) ) {
					def m = (sec / 60) as int;
					def s = sec - m*60;
					def time;
					if((m != 0) && (s != 0)) {
						time = strings.getString("notice.minsec",m,s);
						//notice.minsec=%S分%S秒
					} else {
						if(m == 0) {
							time = strings.getString("notice.sec",s);
							//notice.sec=%S秒
						} else {
							time = strings.getString("notice.min",m);
							//notice.min=%S分
						}
					}
					if(check.size() > 0) {
						check.each {
							it.notice(strings.getString("notice.role.execute.remainingtime",time));
							//notice.role.execute.remainingtime=あと%Sです。早く役職実行をお願いします。
						}
					}
					if(JinroGame.day > 0) {
						if(!Wolf.bitetarget) {
							if(wolveschat != null) {
								wolveschat.send(strings.getString("notice.role.execute.remainingtime", time));
							}
						}
					}
				}
				break;
		}
		return true;
	}
	// Frequency of revotes
	def revoteCount = 0;
	// Calls when start argument/night time.
	// This method is called by JinroGame.changePhase().
	//議論時間・夜時間を開始するときに呼び出されます。
	def startPhase() {
		if(JinroGame.time + firstdaytime*2 != 7) {
			if(judge()) {
				return;
			}
		}
		time0++;
		checkstepnum = -1;

		//霊界チャット
		if(autospiritschat == true) {
			if(spiritschat == null) {
				if(spirits.size() > 1) {
					def skypeids = [];
					spirits.each { actor ->
						if(spiritschatlist.any{it.skypeid == actor.skypeid} == false) {
							skypeids << actor.skypeid;
							spiritschatlist << actor;
						}
						actor.notice(strings.getString("notice.spirits.thank", actor.name))
						//notice.spirits.thank=%Sさんお疲れ様でした。霊界でお楽しみください。
					}
					def topic = strings.getString("notice.spirits");
					//notice.spirits=霊界チャット
					spiritschat = JinroSkype.notice(skypeids as String[], topic);
					spiritschat.setTopic(topic);
					spirits = [];
					
				}
			} else {
				spirits.each { actor ->
					if(spiritschatlist.any{it.skypeid == actor.skypeid} == false) {
						def id = actor.skypeid;
						def chat = spiritschat;
						def mess = strings.getString("notice.spirits.adduser", actor.name);
						//notice.spirits.adduser=%Sさんを霊界チャットに追加しました。
						new Thread() {
							public void run() {
								chat.addUser( new User(id) );
								chat.send(mess);
							}
						}.start();
						spiritschatlist << actor;
						
						actor.notice(strings.getString("notice.spirits.thank", actor.name))
						//notice.spirits.thank=%Sさんお疲れ様でした。霊界でお楽しみください。
					}
				}
				spirits = [];
			}
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + firstdaytime*2) {
			case 0:	//昼
				noticeall(strings.getString("notice.start.argument"));
				//notice.start.argument=議論時間を開始します。
				noticeall(strings.getString("notice.vote"));
				//notice.vote=投票時間になったら「投票＠対象の名前」を個人チャットに入力して投票をお願いします。
				
			//	JinroInterface.makeDialogCommands();	//投票画面表示
				
				if(argumenttime < minsectime) {
					JinroInterface.setTimer(argumenttime, 0);
				} else {
					def min = (argumenttime / 60) as Integer;
					def sec = ((argumenttime+60) % 60) as Integer;
					JinroInterface.setTimer(min, sec);
				}
				JinroInterface.countdown = true;		//タイマー動作開始
				revoteCount = 0;
				break;
			case 1:	//夜
				votetimeflg = false;
				voteflg = false;
				votecheckcount = 0;
				daytimeend = false;
				noticeall(strings.getString("notice.start.night"));
				//notice.start.night=夜時間を開始します。
				if(leavingseat == true) {
					noticeall(strings.getString("notice.night.leavingseat"));
					//notice.night.leavingseat=夜時間に離席する場合は「離席＠」と入力して下さい。
				}
				if(deviltrigger == true) {
					if(deviltriggerrand == true) {
						if(JinroGame.day > 0) {
							def civilian2 = actors.findAll { it.roleIs(new Civilian()) && it.isLive() && (it.cupid == false) };
							if(civilian2) {		//村側デビルトリガーランダム選出
								civilian2.get(Math.floor(JinroGame.invokeMethod("rand") * civilian2.size()) as int).deviltrigger = true;
							}
						}
					} else {
						actors.findAll{ it.DTbyCivilian == true && it.isLive() }.each {
							it.deviltrigger = true;		//村側のデビルトリガー
						};
					}
					if(JinroGame.day > 0) {
						def dt2 = [];				//もう一つのデビルトリガー
						switch( (JinroGame.day + 2 + 3) % 3 ) {
							case 0:		//狂人
								dt2 = actors.findAll { it.roleIs(new Lunatic()) && it.isLive() };
								break;
							case 1:		//妖狐
								dt2 = actors.findAll { it.roleIs(new Fox()) && it.isLive() };
								break;
							case 2:		//狩人
								dt2 = actors.findAll { it.roleIs(new Hunter()) && it.isLive() };
								break;
						}
						if(dt2) {
							dt2.get(Math.floor(JinroGame.invokeMethod("rand") * dt2.size()) as int).deviltrigger = true;
						}
					}
				}
				if(usedeathnote == true) {
					def lives2 = actors.findAll { it.isLive() };
					deathnotenext = lives2.get(Math.floor(JinroGame.invokeMethod("rand") * lives2.size()) as int);
				}
				if(nighttime < minsectime) {
					JinroInterface.setTimer(nighttime, 0);
				} else {
					def min = (nighttime / 60) as Integer;
					def sec = ((nighttime+60) % 60) as Integer;
					JinroInterface.setTimer(min, sec);
				}
				
				JinroInterface.countdown = true;		//タイマー動作開始
				break;
			case 3:	//恋人決め
				noticeall(strings.getString("notice.start.lovers"));
				//notice.start.lovers=恋人決定時間を開始します。
				break;
			case 7:	//希望役職
				noticeall(strings.getString("notice.start.hope1"));
				//notice.start.hope1=役職を希望する事が出来ます。「希望＠役職名」をGMの個人チャットに入力して下さい。
				noticeall(strings.getString("notice.start.hope2"));
				//notice.start.hope2=尚、希望しない場合は「希望＠無し」として下さい。
				
				actors.findAll { it.isLive() && (it.skypeid != null) }.each {
					it.notice(strings.getString("notice.start.hope1"));
					//notice.start.hope1=役職を希望する事が出来ます。「希望＠役職名」をGMの個人チャットに入力して下さい。
					it.notice(strings.getString("notice.start.hope2"));
					//notice.start.hope2=尚、希望しない場合は「希望＠無し」として下さい。
				}
				break;
		}
		actors.findAll{ it.isLive() }.each {
			it.startPhase();
		};
		check = actors.findAll { (it.checkStep() == false) && it.isLive() };	//チェックを初期化
	}
	// Calls when end argument/night time.
	// This method is called by JinroGame.changePhase().
	//議論・夜時間を終了します。処刑や噛みその他update()を実行します。 このメソッドはツール本体から呼び出されるため必須です。
	def endPhase() {
		JinroInterface.countdown = false;	//タイマーを止める
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + firstdaytime*2) {
			case 0:
				execution();
				statecheck();	//生死が変化してないか確認＆表示
			/*	actors.each{
					if(it.state != it.statesave) {
						if(it.state == State.live) {	//生き返り
							noticeall(strings.getString("notice.resuscitation", it.name));
							//notice.resuscitation=%Sさんが生き返りました。
							it.killtime = -1;
						}
						if(it.statesave == State.live) {	//突然死
							noticeall(strings.getString("notice.suddendeath", it.name, it.state.name));
							//notice.suddendeath=%Sさんが%Sしました。"
							it.killtime = time0;
						}
						it.killed(it.state);
					}
				}*/
				break;
			case 1:
				if(JinroGame.day > 0) {
					if(!Wolf.bitetarget.defended) {
						Wolf.bitetarget.nextstate = State.bitten;
						Wolf.bitetarget.countdown = 1;
					}
					actors.findAll{ (it.deviltrigger == true) && it.isLive() }.each {
						def target = it.DTtarget;
						if(target != null) {
							if(target.first == false) {
								if( target.roleIs(new Medium()) || target.roleIs(new Fox()) ) {
									//霊能か妖狐なら失敗して晒される
									it.baka = true;
								} else {
									if( target.roleIs(new Sharer()) || (target.loveguard == true) ) {
										//共有かラブガード先なら撃った人が死ぬ
										it.loveguarddead = true;
									} else {
										//銃殺
										target.shooting = true;
									}
								}
							}
						}
					}
					actors.findAll{ (it.deathnote == true) && it.isLive() }.each {
						def target = it.DNtarget;
						if(target != null) {
							if(target.first == false) {
								target.deathnoteflg = true;
							}
						}
						it.deathnote = false;
					}
				}
				statecheck();	//生死が変化してないか確認＆表示
			/*	actors.each{
					if(it.state != it.statesave) {
						if(it.state == State.live) {	//生き返り
							noticeall(strings.getString("notice.resuscitation", it.name));
							//notice.resuscitation=%Sさんが生き返りました。
						}
						if(it.statesave == State.live) {	//突然死
							noticeall(strings.getString("notice.suddendeath", it.name, it.state.name));
							//notice.suddendeath=%Sさんが%Sしました。"
						}
						it.killed(it.state);
					}
				}*/
				//次の人にデスノート（死神手帳）
				if(usedeathnote == true) {
					if(deathnotenext != null) {
						deathnotenext.deathnote = true;
					}
				}
				deathnotenext = null;
				break;
			case 3:	//恋人決め
				//表示用の文字設定
				actors.each { actor ->
					def loversbit = actor.lovers;
					def keepbit = actor.keep;
					def lstr = "";
					def lcount = 0;
					while((loversbit | keepbit) != 0) {
						if((keepbit & 1) != 0) {
							char c = 'a';
							c += lcount;
							lstr += c.toString( );
						}
						if((loversbit & 1) != 0) {
							char c = 'A';
							c += lcount;
							lstr += c.toString( );
						}
						loversbit >>= 1;
						keepbit >>= 1;
						lcount++;
					}
					actor.loversmark = lstr;
				}
				break;
			case 7:	//希望役職  役職決め
				//初日犠牲者の役職の分、既に配っているので
				listroles.findAll{ (it.number > 0) && (it.name2 == firstvictim.getRoleName()) }.each {
					it.dealfinish++;
				}
				listroles.findAll{ (it.number - it.dealfinish) > 0 }.each {roles ->
					def num = actors.findAll{ it.isLive() && (it.hoperolefinish == false) && (roles.name == it.hoperolename) };
					if(num.size() > 0) {
												//希望人数が役職人数以下（確定で希望が通る）
						if(num.size() <= (roles.number - roles.dealfinish)) {
							num.each {
								it.setRole(roles.role);
								it.hoperolefinish = true;
								roles.dealfinish++;
							}
						} else {				//希望人数が役職人数を超える（抽選で希望が通る）
							(roles.number - roles.dealfinish).times {
								def choice = num.get(Math.floor(JinroGame.invokeMethod("rand") * num.size()) as int);
								choice.setRole(roles.role);
								choice.hoperolefinish = true;
								num.remove(choice);
								roles.dealfinish++;
							}
						}
					}
				}
				//まだ余ってる人を空いている役職に入れる。
				def rest = actors.findAll{ it.isLive() && (it.hoperolefinish == false) };
				if( rest.size() > 0) {
					listroles.findAll{ (it.number - it.dealfinish) > 0 }.each {roles ->
						(roles.number - roles.dealfinish).times {
							if(rest.size() > 0) {
								def choice = rest.get(Math.floor(JinroGame.invokeMethod("rand") * rest.size()) as int);
								choice.setRole(roles.role);
								choice.hoperolefinish = true;
								rest.remove(choice);
								roles.dealfinish++;
							}
						}
					}
				}
				JinroInterface.refreshUserList();	//役職表示を更新
				dealRoles2();						//配役配布後の処理
				break;
		}
		update();
		Wolf.bitetarget = null;
		actors.findAll{ it.isLive() }.each {
			it.endPhase();
		};
		return true;
	}
	// Checks if the game can go to next phase.
	// This method is called by JinroGame.checkStep().
	//ゲームを進められるかどうかを返します。 このメソッドはツール本体から呼び出されるため必須です。
	def checkStep() {
		def result = actors.find { it.isLive() && !it.checkStep() };
		// 0: 昼, 1: 夜 
		switch(JinroGame.time + firstdaytime*2) {
			case 0:
				def lives = actors.findAll{ it.isLive() };
				if(lives.size() <= 4) {	//最終日か？
					voteflg = true;
			//		noticeall(strings.getString("notice.vote.execute.last"));
					//notice.vote.execute.last=最終日なので投票時間に制限はありません。ゆっくり考えて投票して下さい。
				} else {
					if(votecheckcount < 1) {
						if( (votetime > 0) && (result) ) {
							MessageBox msg = new MessageBox(JinroInterface.getMainwindow(), SWT.ICON_INFORMATION | SWT.OK | SWT.CANCEL);
							msg.setMessage(strings.getString("notice.vote.execute.dialog"));
							//notice.vote.execute.dialog=時間を進めて投票時間にします。
							if(msg.open() == SWT.OK) {
								votecheckcount++;
								votetimeflg = true;
								noticeall(strings.getString("notice.vote.execute"));
								//notice.vote.execute=投票時間です。「投票＠対象の名前」を個人チャットに入力して投票をお願いします。
								if(votetime < minsectime) {
									JinroInterface.setTimer(votetime, 0);
								} else {
									def min = (votetime / 60) as Integer;
									def sec = ((votetime+60) % 60) as Integer;
									JinroInterface.setTimer(min, sec);
								}
								JinroInterface.countdown = true;		//投票時間のタイマー動作開始
							}
						} else {
							voteflg = true;
						}
					} else {
						voteflg = true;
					}
				}
				if(result) { return false; }
				if(!checkExecution()) {
					return false;
				}
				break;
			case 1:
				if(result) { return false; }
				if(JinroGame.day > 0) {
					if(!Wolf.bitetarget) {
						return false;
					}
				}
				break;
			case 3:	//恋人決め
				def flg = true;
				actors.findAll { (it.roleIs(new Cupid()) || it.roleIs(new Wooer()) || it.roleIs(new Wickedwoman()) ) && it.isLive() }.each {	//キューピット
					if(!it.checkStep()) {
						flg = false;
					}
				}
				return flg;
				break;
			case 7:	//希望役職
				if(result) { return false; }
				break;
		}
		return true;
	}
	// Checks if all actors finished vote.
	//処刑投票が終了したかどうかを返します。再投票になる場合はそれを通知した上でfalseを返します。
	def checkExecution() {
		def lives = actors.findAll{ it.isLive() };
		def votes = [];
		lives.each {
			votes << new Vote(it);
		}
		// Tallies up voting results.
		lives.each {
			def target = it.target;
			def ac = votes.find{ target == it.actor }
			if(ac != null) {
				ac.number++;
		/*	} else {
				noticeall("突然死が発生しました。再投票をお願いします。");
				resetActors();
				return false;	//*/
			}
	//		votes.find{ target == it.actor }.number++;
		}
		// Sort the results.
		def collator = Collator.getInstance(JinroLocalization.getLocale());
		collator.setStrength(Collator.PRIMARY);
		votes.sort { one, two ->
			if(one.number == two.number) {
				return collator.compare(one.actor.name, two.actor.name);
			} else {
				return two.number <=> one.number;
			}
		};
		if(votes[0].number == votes[1].number) {
			revoteCount++;
			if(0 < revotelimit && revotelimit < revoteCount) {
				return true;
			} else {
				if(tievoterandom == true) {	//同票ランダム処刑
					revoteCount = 0;
					return true;
				} else {
					def clipboard = new StringBuilder(30 * votes.size());
					def noticebuf0 = [];
					def noticebuf1 = [];
					votes.each {
						noticebuf0 << (strings.getString("notice.vote.result", it.actor.name, it.number, it.actor.target.name));
						clipboard << strings.getString("notice.vote.result", it.actor.name, it.number, it.actor.target.name) << "\n";
						//notice.vote.result=%1$S(%2$S票)の投票先→%3$S
					}
					if(0 < revotelimit) {
						noticebuf1 << (strings.getString("notice.vote.again.limited", revotelimit - revoteCount + 1));
						clipboard << strings.getString("notice.vote.again.limited", revotelimit - revoteCount + 1);
						//notice.vote.again.limited=投票結果に同票が出ました。再投票をお願いします。残り%S回の再投票で決着しない場合は引き分けになります。
					} else {
						noticebuf1 << (strings.getString("notice.vote.again"));
						clipboard << strings.getString("notice.vote.again");
						//notice.vote.again=投票結果に同票が出ました。再投票をお願いします。
					}
					resetActors();
					JinroInterface.copyClipboard(clipboard.toString().denormalize());
					//ラグ対策でウエイトを入れる為に別スレッド動作
					new Thread() {
						public void run() {
							Thread.sleep(waittime);
							noticebuf0.each {
								noticeall(it);
							}
							Thread.sleep(waittime);
							noticebuf1.each {
								noticeall(it);
							}
						}
					}.start();
					return false;
				}
			}
		} else {
			revoteCount = 0;
			return true;
		}
	}
	// Execution
	//処刑処理を実行します。投票結果を通知した上で、決着がついた場合は対象者を処刑し、つかなかった場合は引き分けとします。
	def execution() {
		def votes = [];
		actors.findAll{ it.isLive() }.each {
			votes << new Vote(it);
		}
		// Tallies up voting results.
		actors.findAll{ it.isLive() }.each {
			def target = it.target;
			votes.findAll{ it.actor == target }.each {
				it.number++;
			}
		}
		// Sort the results.
		def collator = Collator.getInstance(JinroLocalization.getLocale());
		collator.setStrength(Collator.PRIMARY);
		votes.sort { one, two ->
			if(one.number == two.number) {
				return collator.compare(one.actor.name, two.actor.name);
			} else {
				return two.number <=> one.number;
			}
		};
		def clipboard = new StringBuilder(30 * votes.size());
		def noticebuf0 = [];
		def noticebuf1 = [];
		votes.each {
			noticebuf0 << (strings.getString("notice.vote.result", it.actor.name, it.number, it.actor.target.name));
			clipboard << strings.getString("notice.vote.result", it.actor.name, it.number, it.actor.target.name) << "\n";
			//notice.vote.result=%1$S(%2$S票)の投票先→%3$S
		}
		if( (votes[0].number == votes[1].number) && (tievoterandom != true) ) {
			noticebuf1 << (strings.getString("notice.drawn"));
			clipboard << strings.getString("notice.drawn");
			//notice.drawn=投票は繰り返し行われましたが、決着しませんでした。
		} else {
			if( (votes[0].number == votes[1].number) && (tievoterandom == true) ) {
				def tie = votes.findAll{votes[0].number == it.number};
				def sel = Math.floor(JinroGame.invokeMethod("rand") * tie.size()) as int;	//ランダムで処刑の人を選ぶ
				def temp = votes[0];
				votes[0] = votes[sel];
				votes[sel] = temp;
				noticebuf1 << (strings.getString("notice.vote.random",votes[0].actor.name));
				clipboard << strings.getString("notice.vote.random",votes[0].actor.name);
				//notice.vote.random=投票結果に同票が出ました。同票の中からランダムで%Sさんが処刑されました。
			} else {
				noticebuf1 << (strings.getString("notice.executed", votes[0].actor.name));
				clipboard << strings.getString("notice.executed", votes[0].actor.name);
				//notice.executed=投票の結果、%Sさんが処刑されました。
			}
			if(votes[0].actor.lovers != 0) { //吊られたのが恋人だった時
				actors.findAll{ it.isLive() && (it.target == votes[0].actor) && (it.lovers == 0)}.each {
					it.voteforlovers = true;
				}
			}
			votes[0].actor.killed(State.executed);
			execactor = votes[0].actor;
		}
		JinroInterface.copyClipboard(clipboard.toString().denormalize());
	/*	//ラグ対策でウエイトを入れる為に別スレッド動作
		new Thread() {
			public void run() {
				Thread.sleep(waittime);
				noticebuf0.each {
					noticeall(it);
				}
				Thread.sleep(waittime);
				noticebuf1.each {
					noticeall(it);
				}
			}
		}.start();*/
		//猫又の投票後即道連れでメッセージの順番がおかしくなるのでとりあえずウェイト無し
		noticebuf0.each { noticeall(it); }
		noticebuf1.each { noticeall(it); }
		
	}
	// Judges victory or defeat.
	//ゲームが終了するかどうかを返します。 startPhase()から呼び出されます。
	def judge() {
	/*	actors.each {
			JinroGame.log.add( "debug00 "+it.name+" : "+it.lovers );
		}*/
		def wolves = actors.findAll { it.isWolf() && it.isLive() };
		def civilians = actors.findAll { it.isCivilian() && it.isLive() };
		def foxes = actors.findAll { (it.roleIs(new Fox()) || it.roleIs(new Minifox())  || it.roleIs(new Foxnine())) && it.isLive() && (it.lovers == 0) };
		def lovers = actors.findAll { it.isLive() && (it.lovers != 0) };
		def loverscount = [];
		def loversmax = 0;
		lovers.each{
			if(loverscount[it.lovers] == null) loverscount[it.lovers] = 0;
			loverscount[it.lovers]++;
			if(loverscount[it.lovers] > loversmax) {
				loversmax = loverscount[it.lovers];
			}
		}
		def result = 0;
		if(0 < revotelimit && revotelimit < revoteCount) {
			noticeall(strings.getString("notice.judge.drawn"));
			//notice.judge.drawn=ゲーム終了：引き分けです！
			result = -1;
			noticeResults(result);
			return true;
		} else if(!wolves) {									//人狼がいない場合
			if(foxes) {											//妖狐が生きていれば妖狐陣営
				noticeall(strings.getString("notice.judge.winners", JinroGame.getAlias((new Fox()).getRoleName())));
				//notice.judge.winners=ゲーム終了：%S陣営の勝利です！
				result = 2;
			}
		//	if(lovers.size() >= 2) {							//恋人が生きていれば恋人陣営
			if(loversmax >= 2) {
				noticeall(strings.getString("notice.judge.winners", strings.getString("lovers") ));
				//notice.judge.winners=ゲーム終了：%S陣営の勝利です！
				result = 3;		//恋人陣営単独勝利
				if(foxes) {
					result = 4;	//恋人陣営＆妖狐陣営勝利
				}
			}
			if( (foxes.size() == 0) && (loversmax < 2) ) {	//村陣営
				if(civilians) {
					noticeall(strings.getString("notice.judge.winners", JinroGame.getAlias((new Civilian()).getRoleName())));
					result = 0;
				} else {										//村人がいない（＝全滅）場合は引き分け
					noticeall(strings.getString("notice.judge.drawn"));
					//notice.judge.drawn=ゲーム終了：引き分けです！
					result = -1;
				}
			}
			noticeResults(result);
			return true;
		} else {
			if(wolves.size() >= civilians.size()) {				//狼の数が村人より多い場合
				if(foxes) {										//妖狐が生きていれば妖狐陣営
					noticeall(strings.getString("notice.judge.winners", JinroGame.getAlias((new Fox()).getRoleName())));
					result = 2;
				}
				if(loversmax >= 2) {						//恋人が生きていれば恋人陣営
					noticeall(strings.getString("notice.judge.winners", strings.getString("lovers") ));
					//notice.judge.winners=ゲーム終了：%S陣営の勝利です！
					result = 3;		//恋人陣営単独勝利
					if(foxes) {
						result = 4;	//恋人陣営＆妖狐陣営勝利
					}
				}
				if( (foxes.size() == 0) && (loversmax < 2) ) {	//狼陣営
					noticeall(strings.getString("notice.judge.winners", JinroGame.getAlias((new Wolf()).getRoleName())));
					result = 1;
				}
				noticeResults(result);
				return true;
			}
			return false;
		}
	}
	// Notifies all actors the game results.
	//参加者の役職及びゲームの勝敗結果を通知します。非開示モードだった場合は開示に変更します。 judge()から呼び出されます。
	//0=村 1=狼 2=狐 3=恋人 4=狐＋恋人 -1=引き分け
	def noticeResults(result) {
		def sortedactors = actors.clone();
		def clipboard = new StringBuilder(30 * sortedactors.size());
		def collator = Collator.getInstance(JinroLocalization.getLocale());
		collator.setStrength(Collator.PRIMARY);
		sortedactors.sort { one, two ->
			if(result < 0 || one.judge(result) == two.judge(result)) {
				if(one.getPriority() == two.getPriority()) {
					collator.compare(one.name, two.name);
				} else {
					return two.getPriority() <=> one.getPriority();
				}
			} else if(one.judge(result)) {
				return -1;
			} else {
				return 1;
			}
		};
		sortedactors.each { actor ->
			def rolename = JinroGame.getAlias(actor.getRoleName());
			if(deviltriggerrand == false) {
			//	if( (actor.deviltrigger == true) && actor.roleIs(new Civilian()) ) {
				if(actor.DTbyCivilian == true) {
					rolename =  strings.getString("IhaveDT");
					//IhaveDT=村人(デビルトリガー)
				}
			}
		//	if(actor.cupid == true) {
		//		rolename = strings.getString("cupid");
		//	}
			if(actor.lovers != 0) {
				if(cupidnum > 1) {
					rolename = strings.getString("lovers") + actor.loversmark + "(" + rolename + ")";
				} else {
					rolename = strings.getString("lovers") + "(" + rolename + ")";
				}
			/*	if(alllovers == true) {
					rolename = rolename + "恋人グループ" + actor.lovers;
				}*/
			}
			def text = strings.getString("notice.roles.result." + (result < 0 ? "draw" : actor.judge(result) ? "win" : "lose"));
			if( actor.roleIs(new Pig()) ) {  //豚の場合　自分が勝利なら（噛まれたら）引き分けでも勝ち、自分が敗北の時は村と一緒
				text = strings.getString("notice.roles.result." + (actor.judge(result) ? "win" : result < 0 ? "draw" : "lose"));
			}
			if( actor.roleIs(new Mow()) ) {  //牛の場合　自分が勝利なら（吊られても）引き分けでも勝ち、自分が敗北の時は村と一緒
				text = strings.getString("notice.roles.result." + (actor.judge(result) ? "win" : result < 0 ? "draw" : "lose"));
			}
			//notice.roles.result.win=勝利
			//notice.roles.result.lose=敗北
			//notice.roles.result.draw=引き分け
			if( (hoperole != true) || (actor.hoperolename == null) ) {
				//通常の結果表示
				noticeall(strings.getString("notice.roles.result", actor.name, text, rolename));
				clipboard << strings.getString("notice.roles.result", actor.name, text, rolename) << "\n";
				//notice.roles.result=%1$S(%2$S)→%3$S
			} else {
				//希望役職の時の結果表示
				noticeall(strings.getString("notice.roles.hope.result", actor.name, text, rolename, actor.hoperolename));
				clipboard << strings.getString("notice.roles.hope.result", actor.name, text, rolename, actor.hoperolename) << "\n";
				//notice.roles.hope.result=%1$S(%2$S)→%3$S (希望→%4$S)
			}
		}
		JinroInterface.copyClipboard(clipboard.toString().denormalize());
		// Shows the results for viewers. 結果表示
		//issecret = false;
		gameend = true;
	}
	// Goes to next phase.
	//時間を進め、朝は死亡者を通知します。 
	//また各参加者のupdateメソッドをそれぞれ役職のupdate順にしたがって実行し、resetActors()も実行します。 endPhase()から呼び出されます。
	def update() {
		def lives = actors.findAll { it.isLive() };
		//0=昼 1=夜 //未定→2=恋人タイム 3=希望役職
		ktime = JinroGame.time;
		def jtime = JinroGame.time;
		switch(jtime + firstdaytime*2) {
			case 0:	//0=昼
				JinroGame.time = 1;
				if(!(0 < revotelimit && revotelimit < revoteCount)) {
					noticeall(strings.getString("notice.datetime", JinroGame.day, strings.getString("notice.datetime.night")));
					//notice.datetime=%1$S日目の%2$Sになりました。
					//notice.datetime.night=夜
				}
				break;
			case 1:	//1=夜
				JinroGame.time--;
				JinroGame.day++;
				noticeall(strings.getString("notice.datetime", JinroGame.day, strings.getString("notice.datetime.morning")));
				//notice.datetime=%1$S日目の%2$Sになりました。
				//notice.datetime.morning=朝
				break;
			case 3://キューピットの恋人選び時間
				firstdaytime--;
				noticeall(strings.getString("notice.datetime", JinroGame.day, strings.getString("notice.datetime.night")));
				//notice.datetime=%1$S日目の%2$Sになりました。
				//notice.datetime.night=夜
				return;
				break;
		/*	case 5://神話マニア時間
				noticeall("aaaa000");
				firstdaytime = 0;
				if(lives.any{ it.roleIs(new Cupid()) || it.roleIs(new Wooer()) }) {	//恋人が居れば恋人時間
					firstdaytime = 1;
				}
				return;
				break;//*/
			case 7:	//希望役職
				firstdaytime = 0;
				if(lives.any{ it.roleIs(new Cupid()) || it.roleIs(new Wooer()) || it.roleIs(new Wickedwoman()) }) {	//恋人が居れば恋人時間
					firstdaytime = 1;
				}
			//	if(lives.any{ it.roleIs(new Mythmania())  }) {	//神話マニア時間
			//		firstdaytime = 2;
			//	}
				noticeRoles();						//役職通知
				return;
				break;
		}
		lives.size().times { i ->
			lives.size().times { j ->
				if((j - i) * lives[i].getUpdatePriority(lives[j]) < 0 ||
				   (i - j) * lives[j].getUpdatePriority(lives[i]) < 0) {
					def temp = lives[i];
					lives[i] = lives[j];
					lives[j] = temp;
				}
			};
		};
		//猫又自己蘇生
		if(catrevival == true) {
			def catd = actors.findAll { (!it.isLive()) && it.roleIs(new Cat()) };
			if(catd.size() > 0) {
				catd.each {
					it.selfrevival();
				}
			}
		}
		lives.each {
			it.update()
		};
		if(killedMessages) {
			Collections.shuffle(killedMessages);	//死亡メッセージをシャッフル
			killedMessages.each { noticeall(it) };	//死亡メッセージを表示
		} else {
			if(JinroGame.time == 0) {
				noticeall(strings.getString("notice.peace"));	//朝に死亡メッセージが無い場合は平和のメッセージ
				//notice.peace=平和な朝を迎えました。
			}
		}
		killedMessages.clear();
		if(JinroGame.time == 0) {
			def bakers = actors.findAll{ it.isLive() && it.roleIs(new Baker()) };
			Collections.shuffle(bakers);
			bakers.each {
				if(it.breadname != null) {
					noticeall(strings.getString("notice.baker", it.breadname));
					//notice.baker=パン屋がおいしい%Sを焼いてくれました♪
				}
			};
			if((oldbakersize > 0) && (bakers.size() == 0)) {
				noticeall(strings.getString("notice.baker.death"));
				//notice.baker.death=今日からはもうおいしいパンが食べられません・・・
			}
			oldbakersize = bakers.size();
		}
		resetActors();
		if(ktime == 1) {
			if(survivalnumber == true) {
				noticeall(strings.getString("notice.survivalnumber",actors.findAll { it.isLive() }.size() ));
				//notice.survivalnumber=現在%S名生存です。
			}
		}
		ktime = (ktime == 0)?1:0;
	}
	def dealRoles() {
		killedMessages.clear();
		super.dealRoles();
		revoteCount = 0;
	}
	def noticeKilled(message) {
		killedMessages << message;
	}
	def resetActors() {
		actors.each { it.reset() };
	}
	def rand() {
//		return Math.random();
		return r.nextDouble();
	}
	def statecheck() {
		//生死が変化してないか確認＆表示
		actors.each{
			if(it.state != it.statesave) {
				if(it.state == State.live) {	//生き返り
					noticeall(strings.getString("notice.resuscitation", it.name));
					//notice.resuscitation=%Sさんが生き返りました。
					it.killtime = -1;
				}
				if(it.statesave == State.live) {	//突然死
					noticeKilled(strings.getString("notice.killed.normal", it.name));
					//notice.killed.normal=%Sさんが無残な死体となって発見されました・・・。
					//noticeall(strings.getString("notice.suddendeath", it.name, it.state.name));
					//notice.suddendeath=%Sさんが%Sしました。"
					it.killtime = time0;
					it.killed(it.state);
				}
			}
		}
	}
	def spiritschatsend(mess) {
		if(spiritschat != null) {
			spiritschat.send(mess);
		}
	}
	def optiondisplay() {
		if(roledisplaymethod == 0) {
			return;
		}
	//	noticeall(strings.getString("option.issecret") + ((issecret == true)?" 有効":" 無効"));				//非公開
		
		def listroles = JinroGame.getProperty("listroles");
		def actorsname = [];
		listroles.each { role ->
			role.number.times{ actorsname << role.name2 };		//alias前の元の役職名
		}
		
		if(tievoterandom == true) {
			noticeall(strings.getString("option.tievoterandom") + " 有効");		//同票ランダム
		}
		if(usedeathnote == true) {
			noticeall(strings.getString("option.usedeathnote") + " 有効");		//デスノート
		}
		if(deviltrigger == true) {
			noticeall(strings.getString("option.deviltrigger") + " 有効");		//デビトリ
		}
	//	if((foxchat == true) && (actors.findAll { it.roleIs(new Fox()) || it.roleIs(new Foxnine())}.size() > 1)) {
		if((foxchat == true) && actorsname.findAll { it == (new Fox()).getRoleName() || it == (new Foxnine()).getRoleName() }.size() > 1) {
			noticeall(strings.getString("option.foxchat") + " 有効");			//妖狐の念話
		}
		if((minifoxchat == true) && actorsname.findAll { it == (new Minifox()).getRoleName() }.size() > 1) {
			noticeall(strings.getString("option.minifoxchat") + " 有効");		//子狐チャット
		}
		if((norenzokuguard == true) && actorsname.findAll { it == (new Hunter()).getRoleName() }.size() >= 1) {
			noticeall(strings.getString("option.norenzokuguard") );				//狩人の連続護衛禁止
		}
	//	if((fanatic == true) && (actors.findAll { it.roleIs(new Lunatic()) }.size() > 0)) {
	//		noticeall(strings.getString("option.fanatic") + " 有効");			//狂信者
	//	}
		if(cupidnum > 0) {
			noticeall(strings.getString("option.loversfellow") + ((loversfellow == true)?" 有効":" 無効"));	//恋人道連れ
		}
	//	if(actors.findAll { it.roleIs(new Cat()) }.size() > 0) {
		if(actorsname.findAll { it == (new Cat()).getRoleName() }.size() > 0) {
			noticeall(strings.getString("option.cathang") + ((cathang == true)?" 有効":" 無効"));				//猫吊り即るー
			noticeall(strings.getString("option.catbitecurse") + ((catbitecurse == true)?" 有効":" 無効"));	//猫噛み狼死亡
			noticeall(strings.getString("option.catrevival") + ((catrevival == true)?" 有効":" 無効"));	//猫又蘇生
			noticeall(strings.getString("option.catascetic") + ((catascetic == true)?" 有効":" 無効"));	//猫又を修験者
		}
		if(zerodayrandom == true) {
			noticeall(strings.getString("option.zerodayrandom") + " 有効");	//初日、役職をランダムで実行
		}
		if(zerodayrandombeginners == true) {
			noticeall(strings.getString("option.zerodayrandombeginners") + " 有効");	//初日役職ランダム実行のとき村側のみ
		}
		if(zerodaynofortune == true) {
			noticeall(strings.getString("option.zerodaynofortune") + " 有効");	//初日は占い無し 
		}
	//	if(actors.findAll { it.roleIs(new Fox()) || it.roleIs(new Foxnine())}.size() > 0) {
		if(actorsname.findAll { it == (new Fox()).getRoleName() || it == (new Foxnine()).getRoleName() }.size() > 0) {
			noticeall(strings.getString("option.firstfortune") + ((firstfortune == true)?" 有効":" 無効"));	//初日犠牲者は占いを行う
		}
	/*	if( (randomloversflg == true) && (randomlovers > 0) ) {
			noticeall(strings.getString("option.randomlovers") + " " + randomlovers + "組");	//ランダム恋人カップル数
		}//*/
		
	}
}

//投票集計用クラス
class Vote {
	def actor;
	def number = 0;
	Vote(actor) {
		this.actor = actor;
	}
}
