package scripts;

import scripts.*;
import scripts.roles.*;

class Actor {
	def name;					// Actor's name
	def skypeid = null;			// Actor's Skype ID
	def state = State.live;		// State of live/dead
	def nextstate = State.live;	// Next state of live/dead
	def countdown = 0;			// Changing state timer		stateがnextstateに変化するまでの期間を表します。カウントが1から0へ変わったときに状態も変化します。
	def role;					// Actor's role				参加者の役職を表します。
	def target;					// Target for action		能力の実行対象を表します。
	def target2;				//２人目の対象者
	def oldtargetname;			//古い対象者の名前
	def breadname;				//パンの名前
	def noticelog = [];			// Notified log
	def defended = false;		// Defended by Hunter		その時間中狩人から護衛されているかどうかを表します。
	def divined = false;		// Divined by fortuneteller	その時間中占い師から占われたかどうかを表します。
	def suspended = null;		// Suspended a command		留保されているコマンドを表します。
	def bitetarget2;			//噛み先
	def killtime = -1;			//死んだ日時を表します。順番に表示用 day*2+time
	def deathnote = false;		//デスノートを持ってる時にtrue
	def DNtarget;				//デスノートの対象者
	def DNsealtarget = false;	//デスノート封印
	def deathnoteflg = false;	//デスノートの対象になるとtrue
	def first = false;			//初日犠牲者（デビルトリガーを撃たない用）
	def loveguard = false;		//ラブガードされているかを表します。
	def deviltrigger = false;	//デビルトリガーを持っているかを表します（持っている=true）
	def DTbyCivilian = false;	//村側のデビルトリガー所持者
	def DTtarget;				//デビルトリガー対象者
	def DTsealtarget = false;	//デビルトリガー封印
	def sealtarget = false;		//役職実行封印（狼占い、九尾、背徳用）
	def	baka = false;			//バカ=true（デビルトリガーで霊能か妖狐を撃った時にtrueになる）
	def shooting = false;		//銃殺されるとtrue;
	def loveguarddead = false;	//ラブガードで死ぬとtrue
	def cupid = 0;				//キューピット＆求愛者の番号　0=無し
	def lovers = 0;				//恋人の時true 0=恋人ではない。　1～　同じ数字で同じ恋人
	def loverslive = true;		//恋人道連れの生死判別用
	def keep = 0;				//0!=悪女のキープ
	def loversmark = "";		//恋人の番号（表示用）
	def voteforlovers = false;	//恋人に投票した人
	def hoperolename = null;	//希望する役職名
	def hoperolefinish = false;	//役職希望済 true=済
	def mania = null;			//神話マニアの希望有無？(NULL=希望前)
	def norevival = false;		//猫又でコマンド蘇生しない＠ true=蘇生しない
	def revivalsuccess = false;	//猫又蘇生 true=成功
	def revivaltarget;			//蘇生対象（誤爆含む）
	def statesave = State.live;	// stateの保存（変化検出用）
	def rolenamesave;			// roleの保存（変化検出用）

	def voted = false;			//投票済
	
	//指定の参加者名でインスタンスを作成します。
	Actor(name) {
		this.name = name;
		setRole(Civilian);
	}
	//役職を設定します。
	def setRole(role) {
		this.role = role.newInstance(this);
	}
	//ここに無いメソッドが呼び出されたときにこれが呼び出され、役職インスタンスのメソッドを実行します。
	def methodMissing(String name, args) {
		return role.invokeMethod(name, args);
	}
}
