package scripts;

import jinro.*;

// State of live/dead

enum State {
	live("live", 100),
	suddendeath("suddendeath", 50),
	executed("executed", 49),
	bitten("bitten", 45),
	cursed("cursed", 40),
	followed("followed", 35),
	followed2("followed2", 34),
	sacrifice("sacrifice", 30),
	recursed("recursed", 25),
	shooting("shooting", 23),
	loveguard("loveguard", 22),
	followup("followup", 21),
	pray("pray", 20),
	deathnote("deathnote", 19),
	escaped("escaped", 5),

	def name;
	def priority;
	State(name, priority) {
		this.name = JinroLocalization.getBundle("State.properties").getString(name);
		this.priority = priority;
	}
}
