package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Medium
// Camp: Civilians

class Itako extends Civilian {
	def static order = 15;
	def static strings = Civilian.strings.attachBundle("roles/Itako.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	def getPriority() {
		return 46;
	}
	Itako(actor = null) {
		super(actor);
	}
	def getRoleName() {
		return strings.getString("itako");
		//itako=いたこ
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase();
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 1:
				if(JinroGame.day == 0) {
					return;
				}
				medium();
				break;
		}
	}
	def medium() {
		def execactor = JinroGame.getProperty("execactor");
		notice(strings.getString("notice.medium.result", execactor.name, execactor.getRoleName() ));
		//notice.medium.result=%1$Sさんは%2$Sです。
	}
}
