package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Mow
// Camp: Solo

class Mow extends Civilian {
	def static order = 25;
	def static strings = Civilian.strings.attachBundle("roles/Mow.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	Mow(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 53;
	}
	def getRoleName() {
		return strings.getString("mow");
		//mow=牛
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	def judge(result) {
		if(lovers != 0) {
			def lover = JinroGame.getActors().findAll { ((it.lovers & this.lovers) != 0) && it.isLive() };
			def lovercount = [];
			def lovermax = 0;
			lover.each {
				if(lovercount[it.lovers] == null) lovercount[it.lovers] = 1;
				lovercount[it.lovers]++;
				if(lovercount[it.lovers] > lovermax) {
					lovermax = lovercount[it.lovers];
				}
			}
			if(lovermax >= 2) {
				return (result == 3) || (result == 4);	//恋人
			} else {
				return false;
			}
		}
		return state == State.executed;
	}
}
