package scripts.roles;

import scripts.*;
import jinro.*;

// Role: 大狼
// Camp: Wolves

class Wolfhead extends Wolf {
	def static order = 20;
	def static strings = Wolf.strings.attachBundle("roles/Wolfhead.properties");
	def static number = 0;	// All roles must define own "number" property.
	def static bite = true;	// All roles must define own "bite" property.
	def static isInvisible() {
		return true;
	}
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	def getPriority() {
		return 99;
	}
	Wolfhead(actor = null) {
		super(actor);
	}
	def getRoleName() {
		return strings.getString("wolfhead");
		//wolfhead=大狼
	}
}
